(ns com.aurellem.items
  (:use (com.aurellem gb-driver vbm title))
  ;; this is bullshit
  (:import [com.aurellem.gb_driver SaveState]))

(defn game-name []
  (map char (subvec (vec (memory)) 0x134 0x142)))

(def item-list-start 0xD31C)

(defn item-list [^SaveState state]
  (subvec
   (vec (memory state))
   item-list-start
   (+ item-list-start 150)))

(def item-hack-3 (read-state 77557))

(def item-code->item-name
  (hash-map
   1     :master-ball
   2     :ultra-ball
   3     :great-ball
   4     :poke-ball
   5     :town-map
   6     :bicycle
   8     :safari-ball
   9     :pokedex
   10    :moon-stone 
   11    :antidote
   12    :burn-heal
   13    :ice-heal
   14    :awakening
   15    :parlyz-heal
   16    :full-restore
   17    :max-potion
   18    :hyper-potion
   19    :super-potion
   20    :potion
   21    :boulderbadge
   22    :cascadebadge
   23    :thunderbadge
   24    :rainbowbadge
   25    :soulbadge
   26    :marshbadge
   27    :volcanobadge
   28    :earthbadge
   29    :escape-rope
   30    :repel
   31    :old-amber
   32    :fire-stone
   33    :thunderstone
   34    :water-stone
   35    :hp-up
   36    :protein
   37    :iron
   38    :carbos
   39    :calcium
   40    :rare-candy
   41    :dome-fossil
   42    :helix-fossil
   43    :secret-key
   45    :bike-voucher
   46    :x-accuracy
   47    :leaf-stone
   48    :card-key
   49    :nugget
   50    :pp-up
   51    :poke-doll
   52    :full-heal
   53    :revive
   54    :max-revive
   55    :guard-spec
   56    :super-repel
   57    :max-repel
   58    :dire-hit
   59    :coin
   60    :fresh-water
   61    :soda-pop
   62    :lemonade
   63    :s.s.ticket
   64    :gold-teeth
   65    :x-attach
   66    :x-defend
   67    :x-speed
   68    :x-special
   69    :coin-case
   70    :oaks-parcel
   71    :itemfinder
   72    :silph-scope
   73    :poke-flute
   74    :lift-key
   75    :exp.all
   76    :old-rod
   77    :good-rod
   78    :super-rod
   79    :pp-up
   80    :ether
   81    :max-ether
   82    :elixer
   83    :max-elixer
   196   :HM01  ;; cut
   197   :HM02  ;; fly
   198   :HM03  ;; surf
   199   :HM04  ;; strength
   200   :HM05  ;; flash
   201   :TM01  ;; mega punch
   202   :TM02  ;; razor wind
   203   :TM03  ;; swords dance
   204   :TM04  ;; whirlwind
   205   :TM05  ;; mega kick
   206   :TM06  ;; toxic
   207   :TM07  ;; horn drill
   208   :TM08  ;; body slam
   209   :TM09  ;; take down
   210   :TM10  ;; double-edge
   211   :TM11  ;; bubblebeam
   212   :TM12  ;; water gun
   213   :TM13  ;; ice beam 
   214   :TM14  ;; blizzard
   215   :TM15  ;; hyper beam
   216   :TM16  ;; pay day
   217   :TM17  ;; submission
   218   :TM18  ;; counter
   219   :TM19  ;; seismic toss
   220   :TM20  ;; rage
   221   :TM21  ;; mega drain
   222   :TM22  ;; solarbeam
   223   :TM23  ;; dragon rage
   224   :TM24  ;; thunderbolt
   225   :TM25  ;; thunder
   226   :TM26  ;; earthquake
   227   :TM27  ;; fissure
   228   :TM28  ;; dig
   229   :TM29  ;; psychic 
   230   :TM30  ;; teleport
   231   :TM31  ;; mimic
   232   :TM32  ;; double team
   233   :TM33  ;; reflect
   234   :TM34  ;; bide
   235   :TM35  ;; metronome
   236   :TM36  ;; self destruct
   237   :TM37  ;; eggbomb
   238   :TM38  ;; fire blast
   239   :TM39  ;; swift
   240   :TM40  ;; skull bash
   241   :TM41  ;; softboiled
   242   :TM42  ;; dream eater
   243   :TM43  ;; sky attack
   244   :TM44  ;; rest
   245   :TM45  ;; thunder wave
   246   :TM46  ;; psywave
   247   :TM47  ;; explosion
   248   :TM48  ;; rock slide
   249   :TM49  ;; tri attack
   250   :TM50  ;; substitute
   251   :TM51  ;; "cut"
   252   :TM52  ;; "fly"
   253   :TM53  ;; "surf"
   254   :TM54  ;; "strength"
   255   :end-of-list-sentinel))

(def item-name->item-code
  (zipmap (vals item-code->item-name)
          (keys item-code->item-name)))

(defn inventory [^SaveState state]
  (let [items (item-list state)]
    (map
     (fn [[item-code quantity]]
          [(item-code->item-name item-code)
           quantity])
     (partition
      2
      (next (take-while (partial not= 255) items))))))

(defn print-inventory
  ([] (print-inventory @current-state))
  ([^SaveState state]
     (println
      (let [inv (inventory state)]
        (reduce
         str
         (concat
          ["+-------------------+----------+\n"
           "|##| Item           | Quantity |\n"
           "+--+----------------+----------+\n"]

          (map
           (fn [index [item-name quantity]]
             (str 
              (format "|%-2d| %-14s | %3d      |\n" index
                      (apply str (rest (str item-name)))
                      quantity)))
           (range 0 (count inv)) inv)
          ["+--+----------------+----------+\n"]))))))

(defn inventory-codes [inventory]
  (flatten
   (concat [(count inventory)]
           (map (fn [[item-name quantity]]
                  [(item-name->item-code item-name)
                   quantity]) inventory)
           [(item-name->item-code :end-of-list-sentinel)])))
  
(defn set-inventory [^SaveState state new-inventory]
  (set-state! state)
  (let [mem (memory state)
        inv (inventory-codes new-inventory)]
  
    (dorun (map (fn [index val]
                  (aset mem index val))
                (range item-list-start
                       (+ item-list-start (count inv))) inv))
    (write-memory! mem)
    (update-state)))

(def gliched-tms
  [[:TM51 1]
   [:TM52 1]
   [:TM53 1]
   [:TM54 1]])

(def good-items
  [[:bicycle 1]
   [:ultra-ball 15]
   [:pp-up 1]
   [:master-ball 5]
   [:rare-candy 99]
   [:full-restore 25]
   [:max-revive 8]
   [:max-repel 40]
   [:TM25 1]
   [:TM11 1]
   [:TM15 1]
   ])
  
(def some-badges
  [[:cascadebadge 1]
   [:thunderbadge 1]
   [:rainbowbadge 1]
   [:soulbadge 1]    
   ])
  
(defn run-item-program
  "This is my first assembly/item program!
   it just increments BC by one.

   The code places a single 'great ball' at the beginning of the
   inventory, then directly sets the program counter to start
   executing at the position of the 'great ball' in memory.

   Since a 'great ball' is represented in memory as 0x03, which
   corresponts to the opcode which increments BC by one, that is
   what happens.

   Obviously, the game crashes more or less immediately after the
   program counter advances past the 'great ball' into the next items
   in the inventory."
  []
  (set-inventory (read-state 578544) [[:great-ball 1]])
  (print-inventory)
  (println "3 ticks") (tick) (tick) (tick)
  (println "PC before:" (PC))
  (println "BC before:" (BC))
  (PC! (inc item-list-start))
  (println "PC after setting:" (PC))
  (println "data at PC:" (aget (memory) (PC)))
  (println "one tick")
  (tick)
  (println "PC after one tick:" (PC))
  (println "BC after one tick:" (BC)))
		